﻿#ifndef SYSENUMLIST_H
#define SYSENUMLIST_H

#include <QModelIndex>

#include <topcore/topclassabs.h>

class QHBoxLayout;
class TUiLoader;
class TTableView;
class TSearchEntry;

class SysEnumList : public TopClassAbs
{
    Q_OBJECT
public:
    explicit SysEnumList(const QString &iModuleNameStr = QString(""),
                         const QVariantMap &iUrlPars = QVariantMap(),
                         QWidget *iParent = nullptr);
    ~SysEnumList();

public slots:
    void reload();
    void copy();
    void create();

    void clearData();
    void setData(const QVariantMap &iDataMap);
    QVariantMap getData() const;
    void saveData();

    void addItem();
    void removeItems();
    void moveSelectItems(const QString &iDirection);

    void setCanCreate(bool iCanBol);
    bool canCreate();

private slots:
    void onSelectionChanged();
    void tuiDataFillTableView();

protected:
    void uidChangeEvent(const QString &iUidStr) override;
    void resizeEvent(QResizeEvent *iEvent) override;

private:
    void initListUiLoader();
    void initTableView();
    QStringList repeatNameList();

private:
    QHBoxLayout *mBodyLayout = nullptr;
    TUiLoader *mClassUiLoader = nullptr;
    TUiLoader *mListUiLoader = nullptr;
    TTableView *mTableView = nullptr;
    TSearchEntry *mSearchEntry = nullptr;
    QModelIndex mLastSelectIndex;
    bool mCanCreate = true;
};

#endif // SYSENUMLIST_H
