﻿#ifndef SYSENUMLISTMGT_H
#define SYSENUMLISTMGT_H

#include <tdatabaseutil/tsqlselectorv2.h>

#include <topcore/topclassabs.h>

class TTableView;
class TSearchEntry;
class TPageTool;
class TSplitter;
class SysEnumList;

class SysEnumListMgt : public TopClassAbs
{
    Q_OBJECT
public:
    explicit SysEnumListMgt(const QString &iModuleNameStr = QString(""),
                            const QVariantMap &iUrlPars = QVariantMap(),
                            QWidget *iParent = nullptr);
    ~SysEnumListMgt();

public slots:
     void refresh();
     void deleteItem(const QVariantList &iIdLst);
     QVariantList selectItems();
     TopClassAbs *openItem(const QString &iEnumStr);
     void newItem();
     bool canModify();
     bool canCreate();
     void refreshDetail();

private slots:
   void onSelectionChanged();
   void onDetailSaved(const QVariant &iUidStr);
   void searchEnumList(const QString &iSearchStr = "",const QVariant &iOptions = QVariant());
   void onDetailChanged();

private:
    void initTableView();
    TSqlSelectorV2 getSqlSelector();
    void fillTableData(const QVariantList &iDataLst);

private:
    TSplitter *mBodySplitter = nullptr;
    QWidget *mBodyWidget = nullptr;
    TSearchEntry *mSearchEntry = nullptr;
    TTableView *mTableView = nullptr;
    SysEnumList *mDetailView = nullptr;
    QVariantList mSelectedKeyLst;
    QString mModeStr;
    QStringList mUserClassLst;
};

#endif // SYSENUMLISTMGT_H
