﻿#include "sysenumlistmgtthread.h"
#include <tbaseutil/tdataresponse.h>
#include <tdatabaseutil/tsqlconnectionpoolv2.h>
#include <tdatabaseutil/tsqlqueryv2.h>
#include <tdatabaseutil/tsqlselectorv2.h>

SysEnumListMgtThread::SysEnumListMgtThread(QObject *iParent)
    : TopClassThreadAbs(iParent)
{

}

SysEnumListMgtThread::~SysEnumListMgtThread()
{

}

void SysEnumListMgtThread::run()
{
    if (invokeName() == "DELETE_ENUM") {
        deleteEnumList();
    }
}

void SysEnumListMgtThread::deleteEnumList()
{
    TDataResponse dataRes;
    TSqlQueryV2 sqlQuery(T_SQLCNT_POOL->getSqlDatabase());
    sqlQuery.begin();
    try {
        TSqlDeleterV2 deleter;
        deleter.setTable("sys_setting_enum");
        deleter.setWhere("enum_name", invokeParameter());
        sqlQuery.deleteRow(deleter);
        if (sqlQuery.lastError().isValid()) {
            throw sqlQuery.lastError();
        }
        sqlQuery.commit();
        setInvokeResult(dataRes.toVariantMap());
        return;
    } catch (const TError &err) {
        dataRes.setError(err);
    } catch (...) {
        dataRes.setErrText(ttr("Unknow Error!"));
    }
    sqlQuery.rollback();
    setInvokeResult(dataRes.toVariantMap());
}
